/**
 * @file FootyDoc.h
 * @brief hLgǗNX̎
 * @author ShinjiWatanabe
 * @version 1.0
 */

#pragma once

#include "EditPosition.h"
#include "UndoBuffer.h"
#include "EthicLine.h"
#include "RegExpContainer.h"


class CFootyDoc
{
public:
	// RXgN^
	CFootyDoc();
	virtual ~CFootyDoc();

	//! VK쐬
	void CreateNew(int nGlobalID);
	
	//! ǂ͈̔͂`悷Kv̂
	enum RedrawType
	{
		REDRAW_FAILED,				//!< ֐s
		REDRAW_NONE,				//!< ĕ`KvȂ
		REDRAW_LINE,				//!< ̍ŝݍĕ`悷
		REDRAW_CURMOVE,				//!< J[\ړɔĕ`̂
		REDRAW_SCROLLED,			//!< XN[ꂽ
		REDRAW_SELCHANGED,			//!< IԂ݂̂ω
		REDRAW_ALL,					//!< Sčĕ`悷Kv
	};

	// f[^
	void SetText(const wchar_t *pString);
	RedrawType InsertString(const wchar_t *pString,bool bRecUndo = true,bool bOverwritable = false,bool bMemLineMode = false);
	RedrawType InsertChar(wchar_t wChar);
	RedrawType InsertReturn( bool bIndentMode );
	RedrawType InsertReturnUp( bool bIndentMode );
	RedrawType InsertReturnDown( bool bIndentMode );
	RedrawType Indent();
	RedrawType Unindent();
	RedrawType OnBackSpace();
	RedrawType OnDelete();

	// R}hn
	bool Undo();
	bool Redo();
	RedrawType ClipPaste(HWND hWnd);
	bool ClipCopy(HWND hWnd);
	void SetSavePoint();

	// ړn
	void MoveWordForward();						//!< P΂Č
	void MoveWordBack();						//!< P΂đO

	// n
	bool Search(const wchar_t *szText, int nFlags);

	// In
	bool SetSelectStart(CEditPosition *pStart);
	inline bool SetSelectStart(){return SetSelectStart(&m_cCaretPos);}
	bool SetSelectStart(CUndoBuffer::CPosInfo *pStart);
	bool SetSelectEndNormal(CEditPosition *pEnd);
	bool SetSelectEndNormal(CUndoBuffer::CPosInfo *pEnd);
	inline bool SetSelectEndNormal(){return SetSelectEndNormal(&m_cCaretPos);}
	bool SetSelectEndBox(CEditPosition *pEnd);
	inline void UnSelect(){m_nSelectType = SELECT_NONE;}
	void SelectWord();
	bool GetSelText(std::wstring *pString, LineMode nLineMode = LM_CRLF);
	inline void SetSelLineStart()
	{
		m_cLineSelStartA = *GetSelStart();
		m_cLineSelStartB = *GetSelEnd();
	}
	size_t GetSelLength(LineMode nLineMode = LM_CRLF);
	RedrawType DeleteSelected(CUndoBuffer *pUndoBuffer);
	int ClearSelected();
	void SelectAll();
	
	// f[^擾
	LinePt GetLine(size_t nLine);
	inline LsLines *GetLineList(){return &m_lsLines;}
	inline LinePt GetTopLine(){return m_lsLines.begin();}	//!< 擪s擾
	LinePt GetLastLine();									//!< u{́vŏIs擾
	inline LinePt GetEndLine(){return m_lsLines.end();}		//!< ̃_~[s擾
	inline int GetLineMode() const {return m_nLineMode;}
	inline LineSize GetLineNum() const {return m_lsLines.size();}	//!< s̐擾
	inline size_t GetLapelColumn() const {return m_nLapelColumns;}
	inline int GetLapelMode() const {return m_nLapelMode;}
	inline size_t GetTabLen() const {return m_nTabLen;}
	bool IsEdited();
	inline bool IsInsertMode() const {return m_bInsertMode;}
	int GetRedoRem();
	int GetUndoRem();

	// ꏊn̎擾[`
	inline CEditPosition *GetCaretPosition(){return &m_cCaretPos;}
	inline bool IsSelecting(){return m_nSelectType != SELECT_NONE;}
	inline bool IsBoxSelect(){return m_nSelectType == SELECT_BOX || 
									 m_nSelectType == SELECT_BOX_REV;}
	inline CEditPosition *GetLineSelStartA(){return &m_cLineSelStartA;}
	inline CEditPosition *GetLineSelStartB(){return &m_cLineSelStartB;}
	inline CEthicLine *GetFirstVisible(int nID){return &m_cFirstVisibleLine[nID];}
	CEditPosition *GetSelStart();
	CEditPosition *GetSelEnd();
	
	// ݒ
	void SetLapel(size_t nColumn,int nMode);
	void SetInsertMode(bool bInsertMode);
	inline void SetReadOnly( bool bReadOnly ){ m_bReadOnly = bReadOnly; }
	inline bool IsReadOnly() const { return m_bReadOnly; }
	void SetTabLen(size_t nTabLen);

	// \n̊֐
	bool AddEmphasis(const wchar_t *pString1,const wchar_t *pString2,int nType,
		int nFlags,int nLevel,int nOnLevel,int nIndependence,COLORREF nColor);
	void FlushEmphasis();
	void ClearEmphasis();
	void SetChacheCommand(LinePt pLine);

	// hLgñCxgĂяo
	inline void SendMoveCaretCallBack()
	{
		if (m_pFuncMoveCaret)
			m_pFuncMoveCaret(m_nGlobalID,m_pDataMoveCaret,
							m_cCaretPos.GetLineNum(),m_cCaretPos.GetPosition());
	}
	inline void SendTextModified(int nCause)
	{
		if (m_pFuncTextModified)
			m_pFuncTextModified(m_nGlobalID,m_pDataTextModified,nCause);
	}

private:
	// Tu[`
	void ReturnLine(LinePt *pNowLine,const wchar_t **pString,const wchar_t *pWork,
		size_t nPos,std::wstring *pRestStr,int n,bool bFirst);

	// n
	void ParseRegulaerExpression(const wchar_t *szString,CRegExpContainer *pRegExp);
	bool SearchText(CEditPosition *pStart,CRegExpElement *pRegElement,bool bBackward = false);
	void SelectSearchedWord(LinePt pNowLine,size_t nPosition,CEditPosition *pEndPos);

	// ʃ[`
	bool PushBackUndo(CUndoBuffer *pUndo);
	void DeleteLine(LinePt pLine);
	void DeleteLine(LinePt pStart,LinePt pEnd);
	bool SetLineInfo(LinePt pBegin);
	bool SetLineInfo(LinePt pBegin,LinePt pEnd);
	

public:
	//! I^Cv
	enum SelType
	{
		SELECT_NONE,								//!< IĂȂ
		SELECT_NORMAL,								//!< ʏ̑I
		SELECT_REV,									//!< ㉺t̑I
		SELECT_BOX,									//!< `I
		SELECT_BOX_REV,								//!< ㉺t̋`I
	};
	
	// ֐|C^
	Footy2FuncMoveCaret m_pFuncMoveCaret;			//!< LbgړCxg
	void *m_pDataMoveCaret;							//!< ̃f[^
	Footy2FuncTextModified m_pFuncTextModified;		//!< eLXgҏWꂽƂ̃Cxg
	void *m_pDataTextModified;						//!< eLXgҏWꂽƂ̃f[^
	Footy2FuncInsertModeChanged m_pFuncInsertMode;	//!< }ԂωꂽƂ̃Cxg
	void *m_pDataInsertModeChanged;					//!< }ԂωꂽƂ̃f[^

	void SetSpeedDraw(int flag);					//!< ` by inovia

private:
	// hLgf[^
	LsLines m_lsLines;								//!< ̃f[^
	std::list<CUndoBuffer> m_lsUndoBuffer;			//!< AhD[obt@
	std::list<CUndoBuffer>::iterator m_pNowUndoPos;	//!< ݂̃AhD[ʒu
	LsWords m_lsEmphasisWord;						//!< F
	LineMode m_nLineMode;							//!< sR[h
	bool m_bInsertMode;								//!< CT[g

	// ꏊEI֌W
	CEditPosition m_cCaretPos;						//!< ݃Lbgʒu
	SelType m_nSelectType;							//!< Ĩ^Cv
	CEditPosition m_cSelectBegin;					//!< I̊Jnʒu
	CEditPosition m_cSelectEnd;						//!< ȈIʒu
	CEditPosition m_cLineSelStartA;					//!< sI̊Jnʒu(̏ꏊ̊Jnʒu)
	CEditPosition m_cLineSelStartB;					//!< sI̊Jnʒu(̏ꏊ̏Iʒu)
	CEthicLine m_cFirstVisibleLine[4];				//!< ŏɕ\Ăs

	// r[f[^
	size_t m_nLapelColumns;							//!< er[̐܂Ԃ
	int m_nLapelMode;								//!< r[[h
	size_t m_nTabLen;								//!< ^ủ
	
	// ҏWĂȂ𒲂ׂ邽߂̕ϐ
	std::list<CUndoBuffer>::iterator m_pSavedPos;	//!< Z[u|Cg
	bool m_bCannotReachSavedPos;					//!< Z[u|Cg܂łǂ蒅Ȃ(폜ꂽ)
	
	// ̂قf[^
	bool m_bReadOnly;								//!< ҏW\
	int m_nGlobalID;								//!< eIDԍ
	int f_SpeedDraw;								//!< ` by inovia
};

/*[EOF]*/
